// Copyright (C) 2021-2024 Bundesministerium des Innern und für Heimat, Referat DG II 6, Maßnahmen Enterprise Resource Management und Elektronische Verwaltungsarbeit
//
// SPDX-License-Identifier: MPL-2.0

// tslint:disable
/**
 * eGesetzgebung Platform
 * This is the rest interface offered by the eGesetzgebung Platform backend.  Please provide __JW Access Token__ using button \'Authorize\' to access protected endpoints. Use the following instructions to get token:  1. on CMD/Bash/Terminal: ```curl -d \"client_id=user-management\" -d \"client_secret=INSERT_IAM_SECRET\" -d \"grant_type=password&username=INSERT_USER_EMAIL&password=INSERT_USER_PASSWORD\" \"INSERT_IAM_URL/realms/bund/protocol/openid-connect/token\"``` 2. copy access_token (without quotes, you can use jq or other tools to extract this value automatically) 3. insert value into \'JWToken\' field under \'Authorize\' and press \'Authorize\' 4. now you should have access to user protected endpoint  __FYI:__ token expires after 60 seconds. On non-production systems only a warning is displayed so you can work smoothly, but on production systems you have to frequently provide a new token.
 *
 * The version of the OpenAPI document: 9.0.3
 * 
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

import type { Observable } from 'rxjs';
import type { AjaxResponse } from 'rxjs/ajax';
import { BaseAPI, throwIfNullOrUndefined, encodeURI } from '../runtime';
import type { OperationOpts, HttpHeaders, HttpQuery } from '../runtime';
import type {
    AngelegteDrucksachenPageDTO,
    AnnahmestellePageDTO,
    BrDrucksachenMetaFullResponseDTO,
    BrDrucksachenRequestDTO,
    BrDrucksachenResponseDTO,
    BrDrucksachenTableDTO,
    DrucksacheResponseDTO,
    DrucksachenBemerkungenEntityDTO,
    DrucksachenEntityFullResponseDTO,
    DrucksachenEntityResponseDTO,
    DrucksachenSperrfristEntityDTO,
    DrucksachenStatusTyp,
    DrucksachenTyp,
    DrucksachendatenRequestDTO,
    DrucksachennummerEntityDTO,
    DrucksachennummerEntityResponseDTO,
    DrucksachennummerFreiDTO,
    DrucksachennummerTableDTO,
    DrucksachennummerVorlagenart,
    PaginierungDTO,
    TagesausdruckMailRequestDTO,
    TagesausdruckTableDTO,
    VerschlusssacheRequestDTO,
    VorhabenStatusType,
} from '../models';

export interface AddBemerkungToDrucksacheRequest {
    id: string;
    drucksachenBemerkungenEntityDTO: DrucksachenBemerkungenEntityDTO;
}

export interface CreateDrucksachennummerRequest {
    drucksachennummerEntityDTO: DrucksachennummerEntityDTO;
}

export interface CreateOrUpdateBrDrucksacheRequest {
    brDrucksachenMetaId: string;
    type: DrucksachenTyp;
    brDrucksachenRequestDTO: BrDrucksachenRequestDTO;
}

export interface DeleteBemerkungRequest {
    id: string;
}

export interface DeleteDrucksachennummerRequest {
    id: string;
}

export interface DeleteSperrfristRequest {
    id: string;
}

export interface DeleteVerschlusssacheRequest {
    id: string;
}

export interface GetAngelegteDrucksachenPageRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetBrDrucksacheMetaRequest {
    id: string;
}

export interface GetBrDrucksachenMetaRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetBrDrucksachenMetaGETRequest {
    permissibleDrucksachenStatuses?: Array<DrucksachenStatusTyp>;
    permissibleRvStatuses?: Array<VorhabenStatusType>;
    permissibleVorlagenart?: Array<DrucksachennummerVorlagenart>;
    page?: number;
    size?: number;
    sort?: Array<string>;
}

export interface GetDrucksacheRequest {
    id: string;
}

export interface GetDrucksachenRequest {
    paginierungDTO: PaginierungDTO;
}

export interface GetFreieDrucksachennummernRequest {
    wahlperiode: string;
}

export interface GetTagesausdruckRequest {
    paginierungDTO: PaginierungDTO;
}

export interface ModifyDateReceivedOfficiallyBrRequest {
    id: string;
    dateReceivedOfficially: string;
}

export interface ModifyDrucksachennummerRequest {
    id: string;
    drucksachennummerEntityDTO: DrucksachennummerEntityDTO;
}

export interface ModifyDrucksachenstatusRequest {
    id: string;
    drucksachenstatus: DrucksachenStatusTyp;
}

export interface ModifyEingangsdatumRequest {
    id: string;
    eingangsdatum: string;
}

export interface ModifyEingangsdatumBrRequest {
    id: string;
    eingangsdatum: string;
}

export interface ModifyEuBezugRequest {
    id: string;
    euBezug: boolean;
}

export interface ModifySperrfristRequest {
    id: string;
    drucksachenSperrfristEntityDTO: DrucksachenSperrfristEntityDTO;
}

export interface ModifyVerschlusssacheRequest {
    id: string;
    verschlusssacheRequestDTO: VerschlusssacheRequestDTO;
}

export interface SendTagesausdruckRequest {
    tagesausdruckMailRequestDTO: TagesausdruckMailRequestDTO;
}

export interface SetDrucksacheRequest {
    id: string;
    drucksachendatenRequestDTO: DrucksachendatenRequestDTO;
}

export interface UpdateBemerkungRequest {
    id: string;
    drucksachenBemerkungenEntityDTO: DrucksachenBemerkungenEntityDTO;
}

/**
 * no description
 */
export class PrintControllerApi extends BaseAPI {

    /**
     * Fügt eine weitere Bemerkung zur mit der ID angegebenen Drucksache hinzu
     * Fügt der Drucksache eine Bemerkung hinzu
     */
    addBemerkungToDrucksache({ id, drucksachenBemerkungenEntityDTO }: AddBemerkungToDrucksacheRequest): Observable<void>
    addBemerkungToDrucksache({ id, drucksachenBemerkungenEntityDTO }: AddBemerkungToDrucksacheRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    addBemerkungToDrucksache({ id, drucksachenBemerkungenEntityDTO }: AddBemerkungToDrucksacheRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'addBemerkungToDrucksache');
        throwIfNullOrUndefined(drucksachenBemerkungenEntityDTO, 'drucksachenBemerkungenEntityDTO', 'addBemerkungToDrucksache');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/print/drucksachen/{id}/bemerkung'.replace('{id}', encodeURI(id)),
            method: 'POST',
            headers,
            body: drucksachenBemerkungenEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Reserviert eine neue Drucksachennummer
     * Reserviert eine neue Drucksachennummer
     */
    createDrucksachennummer({ drucksachennummerEntityDTO }: CreateDrucksachennummerRequest): Observable<DrucksachennummerEntityResponseDTO>
    createDrucksachennummer({ drucksachennummerEntityDTO }: CreateDrucksachennummerRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksachennummerEntityResponseDTO>>
    createDrucksachennummer({ drucksachennummerEntityDTO }: CreateDrucksachennummerRequest, opts?: OperationOpts): Observable<DrucksachennummerEntityResponseDTO | AjaxResponse<DrucksachennummerEntityResponseDTO>> {
        throwIfNullOrUndefined(drucksachennummerEntityDTO, 'drucksachennummerEntityDTO', 'createDrucksachennummer');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksachennummerEntityResponseDTO>({
            url: '/print/drucksachennummer',
            method: 'POST',
            headers,
            body: drucksachennummerEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Erstellt oder aktualisiert eine Bundesrats-Drucksache anhand der Bundesrats-Drucksachen-Meta-Id.
     * Erstellt oder aktualisiert eine Bundesrats-Drucksache.
     */
    createOrUpdateBrDrucksache({ brDrucksachenMetaId, type, brDrucksachenRequestDTO }: CreateOrUpdateBrDrucksacheRequest): Observable<BrDrucksachenResponseDTO>
    createOrUpdateBrDrucksache({ brDrucksachenMetaId, type, brDrucksachenRequestDTO }: CreateOrUpdateBrDrucksacheRequest, opts?: OperationOpts): Observable<AjaxResponse<BrDrucksachenResponseDTO>>
    createOrUpdateBrDrucksache({ brDrucksachenMetaId, type, brDrucksachenRequestDTO }: CreateOrUpdateBrDrucksacheRequest, opts?: OperationOpts): Observable<BrDrucksachenResponseDTO | AjaxResponse<BrDrucksachenResponseDTO>> {
        throwIfNullOrUndefined(brDrucksachenMetaId, 'brDrucksachenMetaId', 'createOrUpdateBrDrucksache');
        throwIfNullOrUndefined(type, 'type', 'createOrUpdateBrDrucksache');
        throwIfNullOrUndefined(brDrucksachenRequestDTO, 'brDrucksachenRequestDTO', 'createOrUpdateBrDrucksache');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<BrDrucksachenResponseDTO>({
            url: '/print/brdrucksachen/{brDrucksachenMetaId}/{type}'.replace('{brDrucksachenMetaId}', encodeURI(brDrucksachenMetaId)).replace('{type}', encodeURI(type)),
            method: 'PUT',
            headers,
            body: brDrucksachenRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Löscht die Bemerkung mit der angegebenen ID an der Drucksache
     * Löscht eine Bemerkung der Drucksache
     */
    deleteBemerkung({ id }: DeleteBemerkungRequest): Observable<void>
    deleteBemerkung({ id }: DeleteBemerkungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteBemerkung({ id }: DeleteBemerkungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteBemerkung');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/print/bemerkungen/{id}'.replace('{id}', encodeURI(id)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Löscht die Drucksachennummer mit der angegebenen ID
     * Löscht eine Drucksachennummer
     */
    deleteDrucksachennummer({ id }: DeleteDrucksachennummerRequest): Observable<void>
    deleteDrucksachennummer({ id }: DeleteDrucksachennummerRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteDrucksachennummer({ id }: DeleteDrucksachennummerRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteDrucksachennummer');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/print/drucksachennummern/{id}'.replace('{id}', encodeURI(id)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Löscht die Sperrfrist der mit der ID angegebenen Drucksache
     * Löscht die Sperrfrist einer Drucksache
     */
    deleteSperrfrist({ id }: DeleteSperrfristRequest): Observable<void>
    deleteSperrfrist({ id }: DeleteSperrfristRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteSperrfrist({ id }: DeleteSperrfristRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteSperrfrist');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/print/drucksachen/{id}/sperrfrist'.replace('{id}', encodeURI(id)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Löscht die Verschlussache an einer Drucksache
     * Löscht Verschlusssache einer Drucksache
     */
    deleteVerschlusssache({ id }: DeleteVerschlusssacheRequest): Observable<void>
    deleteVerschlusssache({ id }: DeleteVerschlusssacheRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    deleteVerschlusssache({ id }: DeleteVerschlusssacheRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'deleteVerschlusssache');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/print/drucksachen/{id}/verschlusssache'.replace('{id}', encodeURI(id)),
            method: 'DELETE',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die paginierte Tabelle für die angelegten Drucksachen
     * Lädt angelegte Drucksachen
     */
    getAngelegteDrucksachenPage({ paginierungDTO }: GetAngelegteDrucksachenPageRequest): Observable<AngelegteDrucksachenPageDTO>
    getAngelegteDrucksachenPage({ paginierungDTO }: GetAngelegteDrucksachenPageRequest, opts?: OperationOpts): Observable<AjaxResponse<AngelegteDrucksachenPageDTO>>
    getAngelegteDrucksachenPage({ paginierungDTO }: GetAngelegteDrucksachenPageRequest, opts?: OperationOpts): Observable<AngelegteDrucksachenPageDTO | AjaxResponse<AngelegteDrucksachenPageDTO>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getAngelegteDrucksachenPage');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AngelegteDrucksachenPageDTO>({
            url: '/print/drucksachen/angelegt',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die mit der ID angegebene Bundesrats-Drucksache vollständige zur Bearbeitung.
     * Lädt eine Bundesrats-Drucksache zur Bearbeitung.
     */
    getBrDrucksacheMeta({ id }: GetBrDrucksacheMetaRequest): Observable<BrDrucksachenMetaFullResponseDTO>
    getBrDrucksacheMeta({ id }: GetBrDrucksacheMetaRequest, opts?: OperationOpts): Observable<AjaxResponse<BrDrucksachenMetaFullResponseDTO>>
    getBrDrucksacheMeta({ id }: GetBrDrucksacheMetaRequest, opts?: OperationOpts): Observable<BrDrucksachenMetaFullResponseDTO | AjaxResponse<BrDrucksachenMetaFullResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getBrDrucksacheMeta');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<BrDrucksachenMetaFullResponseDTO>({
            url: '/print/brdrucksachenmeta/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Bundesrats-Drucksachen auf
     * Lädt die Liste der Bundesrats-Drucksachen
     */
    getBrDrucksachenMeta({ paginierungDTO }: GetBrDrucksachenMetaRequest): Observable<BrDrucksachenTableDTO>
    getBrDrucksachenMeta({ paginierungDTO }: GetBrDrucksachenMetaRequest, opts?: OperationOpts): Observable<AjaxResponse<BrDrucksachenTableDTO>>
    getBrDrucksachenMeta({ paginierungDTO }: GetBrDrucksachenMetaRequest, opts?: OperationOpts): Observable<BrDrucksachenTableDTO | AjaxResponse<BrDrucksachenTableDTO>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getBrDrucksachenMeta');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<BrDrucksachenTableDTO>({
            url: '/print/brdrucksachenmeta',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Bundesrats-Drucksachen auf
     * Lädt die Liste der Bundesrats-Drucksachen
     */
    getBrDrucksachenMetaGET({ permissibleDrucksachenStatuses, permissibleRvStatuses, permissibleVorlagenart, page, size, sort }: GetBrDrucksachenMetaGETRequest): Observable<BrDrucksachenTableDTO>
    getBrDrucksachenMetaGET({ permissibleDrucksachenStatuses, permissibleRvStatuses, permissibleVorlagenart, page, size, sort }: GetBrDrucksachenMetaGETRequest, opts?: OperationOpts): Observable<AjaxResponse<BrDrucksachenTableDTO>>
    getBrDrucksachenMetaGET({ permissibleDrucksachenStatuses, permissibleRvStatuses, permissibleVorlagenart, page, size, sort }: GetBrDrucksachenMetaGETRequest, opts?: OperationOpts): Observable<BrDrucksachenTableDTO | AjaxResponse<BrDrucksachenTableDTO>> {

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = {};

        if (permissibleDrucksachenStatuses != null) { query['permissibleDrucksachenStatuses'] = permissibleDrucksachenStatuses; }
        if (permissibleRvStatuses != null) { query['permissibleRvStatuses'] = permissibleRvStatuses; }
        if (permissibleVorlagenart != null) { query['permissibleVorlagenart'] = permissibleVorlagenart; }
        if (page != null) { query['page'] = page; }
        if (size != null) { query['size'] = size; }
        if (sort != null) { query['sort'] = sort; }

        return this.request<BrDrucksachenTableDTO>({
            url: '/print/brdrucksachenmeta',
            method: 'GET',
            headers,
            query,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die mit der ID angegebene Bundestags-Drucksache vollständige zur Bearbeitung.
     * Lädt eine Bundestags-Drucksache zur Bearbeitung.
     */
    getDrucksache({ id }: GetDrucksacheRequest): Observable<DrucksachenEntityFullResponseDTO>
    getDrucksache({ id }: GetDrucksacheRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksachenEntityFullResponseDTO>>
    getDrucksache({ id }: GetDrucksacheRequest, opts?: OperationOpts): Observable<DrucksachenEntityFullResponseDTO | AjaxResponse<DrucksachenEntityFullResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'getDrucksache');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksachenEntityFullResponseDTO>({
            url: '/print/drucksachen/{id}'.replace('{id}', encodeURI(id)),
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Bundestags-Drucksachen auf
     * Lädt die Liste der Bundestags-Drucksachen
     */
    getDrucksachen({ paginierungDTO }: GetDrucksachenRequest): Observable<AnnahmestellePageDTO>
    getDrucksachen({ paginierungDTO }: GetDrucksachenRequest, opts?: OperationOpts): Observable<AjaxResponse<AnnahmestellePageDTO>>
    getDrucksachen({ paginierungDTO }: GetDrucksachenRequest, opts?: OperationOpts): Observable<AnnahmestellePageDTO | AjaxResponse<AnnahmestellePageDTO>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getDrucksachen');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<AnnahmestellePageDTO>({
            url: '/print/drucksachen',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Ruft die Liste der Drucksachennummern auf
     * Lädt die Liste der Drucksachennummern
     */
    getDrucksachennummern(): Observable<Array<DrucksachennummerTableDTO>>
    getDrucksachennummern(opts?: OperationOpts): Observable<AjaxResponse<Array<DrucksachennummerTableDTO>>>
    getDrucksachennummern(opts?: OperationOpts): Observable<Array<DrucksachennummerTableDTO> | AjaxResponse<Array<DrucksachennummerTableDTO>>> {
        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<Array<DrucksachennummerTableDTO>>({
            url: '/print/drucksachennummern',
            method: 'GET',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Liefert die nächste freie Bundestags-Drucksachennummer fuer die angegebene Wahlperiode
     * Liefert die nächste freie Bundestags-Drucksachennummer
     */
    getFreieDrucksachennummern({ wahlperiode }: GetFreieDrucksachennummernRequest): Observable<DrucksachennummerFreiDTO>
    getFreieDrucksachennummern({ wahlperiode }: GetFreieDrucksachennummernRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksachennummerFreiDTO>>
    getFreieDrucksachennummern({ wahlperiode }: GetFreieDrucksachennummernRequest, opts?: OperationOpts): Observable<DrucksachennummerFreiDTO | AjaxResponse<DrucksachennummerFreiDTO>> {
        throwIfNullOrUndefined(wahlperiode, 'wahlperiode', 'getFreieDrucksachennummern');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        const query: HttpQuery = { // required parameters are used directly since they are already checked by throwIfNullOrUndefined
            'wahlperiode': wahlperiode,
        };

        return this.request<DrucksachennummerFreiDTO>({
            url: '/print/freiedrucksachennummer',
            method: 'GET',
            headers,
            query,
        }, opts?.responseOpts);
    };

    /**
     * Lädt die Tabelle für den Tagesausdruck des ausgewählten Zeitraums. Ist kein Zeitraum angegeben, dann für den aktuellen Tag.
     * Lädt den Tagesausdruck
     */
    getTagesausdruck({ paginierungDTO }: GetTagesausdruckRequest): Observable<TagesausdruckTableDTO>
    getTagesausdruck({ paginierungDTO }: GetTagesausdruckRequest, opts?: OperationOpts): Observable<AjaxResponse<TagesausdruckTableDTO>>
    getTagesausdruck({ paginierungDTO }: GetTagesausdruckRequest, opts?: OperationOpts): Observable<TagesausdruckTableDTO | AjaxResponse<TagesausdruckTableDTO>> {
        throwIfNullOrUndefined(paginierungDTO, 'paginierungDTO', 'getTagesausdruck');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<TagesausdruckTableDTO>({
            url: '/print/tagesausdruck',
            method: 'POST',
            headers,
            body: paginierungDTO,
        }, opts?.responseOpts);
    };

    /**
     * Aktualisiert das Eingangsdatum der Bundesrats-Drucksache.
     * Aktualisiert das Eingangsdatum der Bundesrats-Drucksache.
     */
    modifyDateReceivedOfficiallyBr({ id, dateReceivedOfficially }: ModifyDateReceivedOfficiallyBrRequest): Observable<BrDrucksachenMetaFullResponseDTO>
    modifyDateReceivedOfficiallyBr({ id, dateReceivedOfficially }: ModifyDateReceivedOfficiallyBrRequest, opts?: OperationOpts): Observable<AjaxResponse<BrDrucksachenMetaFullResponseDTO>>
    modifyDateReceivedOfficiallyBr({ id, dateReceivedOfficially }: ModifyDateReceivedOfficiallyBrRequest, opts?: OperationOpts): Observable<BrDrucksachenMetaFullResponseDTO | AjaxResponse<BrDrucksachenMetaFullResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyDateReceivedOfficiallyBr');
        throwIfNullOrUndefined(dateReceivedOfficially, 'dateReceivedOfficially', 'modifyDateReceivedOfficiallyBr');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<BrDrucksachenMetaFullResponseDTO>({
            url: '/print/brdrucksachen/{id}/dateReceivedOfficially/{dateReceivedOfficially}'.replace('{id}', encodeURI(id)).replace('{dateReceivedOfficially}', encodeURI(dateReceivedOfficially)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Ändert eine Drucksachennummer
     * Verändert eine Drucksachennummer
     */
    modifyDrucksachennummer({ id, drucksachennummerEntityDTO }: ModifyDrucksachennummerRequest): Observable<DrucksachennummerEntityResponseDTO>
    modifyDrucksachennummer({ id, drucksachennummerEntityDTO }: ModifyDrucksachennummerRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksachennummerEntityResponseDTO>>
    modifyDrucksachennummer({ id, drucksachennummerEntityDTO }: ModifyDrucksachennummerRequest, opts?: OperationOpts): Observable<DrucksachennummerEntityResponseDTO | AjaxResponse<DrucksachennummerEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyDrucksachennummer');
        throwIfNullOrUndefined(drucksachennummerEntityDTO, 'drucksachennummerEntityDTO', 'modifyDrucksachennummer');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksachennummerEntityResponseDTO>({
            url: '/print/drucksachennummern/{id}'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: drucksachennummerEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Aktualisiert den Drucksachenstatus der mit der ID angegebenen Drucksachen
     * Aktualisiert den Drucksachenstatus einer Drucksache
     */
    modifyDrucksachenstatus({ id, drucksachenstatus }: ModifyDrucksachenstatusRequest): Observable<DrucksacheResponseDTO>
    modifyDrucksachenstatus({ id, drucksachenstatus }: ModifyDrucksachenstatusRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksacheResponseDTO>>
    modifyDrucksachenstatus({ id, drucksachenstatus }: ModifyDrucksachenstatusRequest, opts?: OperationOpts): Observable<DrucksacheResponseDTO | AjaxResponse<DrucksacheResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyDrucksachenstatus');
        throwIfNullOrUndefined(drucksachenstatus, 'drucksachenstatus', 'modifyDrucksachenstatus');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksacheResponseDTO>({
            url: '/print/drucksachen/{id}/drucksachenstatus/{drucksachenstatus}'.replace('{id}', encodeURI(id)).replace('{drucksachenstatus}', encodeURI(drucksachenstatus)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Aktualisiert das Eingangsdatum der Bundestags-Drucksache.
     * Aktualisiert das Eingangsdatum der Bundestags-Drucksache.
     */
    modifyEingangsdatum({ id, eingangsdatum }: ModifyEingangsdatumRequest): Observable<DrucksacheResponseDTO>
    modifyEingangsdatum({ id, eingangsdatum }: ModifyEingangsdatumRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksacheResponseDTO>>
    modifyEingangsdatum({ id, eingangsdatum }: ModifyEingangsdatumRequest, opts?: OperationOpts): Observable<DrucksacheResponseDTO | AjaxResponse<DrucksacheResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyEingangsdatum');
        throwIfNullOrUndefined(eingangsdatum, 'eingangsdatum', 'modifyEingangsdatum');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksacheResponseDTO>({
            url: '/print/drucksachen/{id}/eingangsdatum/{eingangsdatum}'.replace('{id}', encodeURI(id)).replace('{eingangsdatum}', encodeURI(eingangsdatum)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Aktualisiert das Eingangsdatum der Bundesrats-Drucksache.
     * Aktualisiert das Eingangsdatum der Bundesrats-Drucksache.
     */
    modifyEingangsdatumBr({ id, eingangsdatum }: ModifyEingangsdatumBrRequest): Observable<BrDrucksachenMetaFullResponseDTO>
    modifyEingangsdatumBr({ id, eingangsdatum }: ModifyEingangsdatumBrRequest, opts?: OperationOpts): Observable<AjaxResponse<BrDrucksachenMetaFullResponseDTO>>
    modifyEingangsdatumBr({ id, eingangsdatum }: ModifyEingangsdatumBrRequest, opts?: OperationOpts): Observable<BrDrucksachenMetaFullResponseDTO | AjaxResponse<BrDrucksachenMetaFullResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyEingangsdatumBr');
        throwIfNullOrUndefined(eingangsdatum, 'eingangsdatum', 'modifyEingangsdatumBr');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<BrDrucksachenMetaFullResponseDTO>({
            url: '/print/brdrucksachen/{id}/eingangsdatum/{eingangsdatum}'.replace('{id}', encodeURI(id)).replace('{eingangsdatum}', encodeURI(eingangsdatum)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Aktualisiert den EU-Bezug der mit der ID angegebenen Drucksachen
     * Aktualisiert den EU-Bezug einer Drucksache
     */
    modifyEuBezug({ id, euBezug }: ModifyEuBezugRequest): Observable<DrucksacheResponseDTO>
    modifyEuBezug({ id, euBezug }: ModifyEuBezugRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksacheResponseDTO>>
    modifyEuBezug({ id, euBezug }: ModifyEuBezugRequest, opts?: OperationOpts): Observable<DrucksacheResponseDTO | AjaxResponse<DrucksacheResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyEuBezug');
        throwIfNullOrUndefined(euBezug, 'euBezug', 'modifyEuBezug');

        const headers: HttpHeaders = {
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksacheResponseDTO>({
            url: '/print/drucksachen/{id}/eu-bezug/{euBezug}'.replace('{id}', encodeURI(id)).replace('{euBezug}', encodeURI(euBezug)),
            method: 'PUT',
            headers,
        }, opts?.responseOpts);
    };

    /**
     * Aktualisiert die Sperrfrist der mit der ID angegebenen Drucksache
     * Aktualisiert die Sperrfrist der Drucksache
     */
    modifySperrfrist({ id, drucksachenSperrfristEntityDTO }: ModifySperrfristRequest): Observable<DrucksachenEntityResponseDTO>
    modifySperrfrist({ id, drucksachenSperrfristEntityDTO }: ModifySperrfristRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksachenEntityResponseDTO>>
    modifySperrfrist({ id, drucksachenSperrfristEntityDTO }: ModifySperrfristRequest, opts?: OperationOpts): Observable<DrucksachenEntityResponseDTO | AjaxResponse<DrucksachenEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifySperrfrist');
        throwIfNullOrUndefined(drucksachenSperrfristEntityDTO, 'drucksachenSperrfristEntityDTO', 'modifySperrfrist');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksachenEntityResponseDTO>({
            url: '/print/drucksachen/{id}/sperrfrist'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: drucksachenSperrfristEntityDTO,
        }, opts?.responseOpts);
    };

    /**
     * Aktualisiert die Verschlusssache einer Drucksache 
     * Aktualisiert die Verschlusssache einer Drucksache
     */
    modifyVerschlusssache({ id, verschlusssacheRequestDTO }: ModifyVerschlusssacheRequest): Observable<DrucksachenEntityResponseDTO>
    modifyVerschlusssache({ id, verschlusssacheRequestDTO }: ModifyVerschlusssacheRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksachenEntityResponseDTO>>
    modifyVerschlusssache({ id, verschlusssacheRequestDTO }: ModifyVerschlusssacheRequest, opts?: OperationOpts): Observable<DrucksachenEntityResponseDTO | AjaxResponse<DrucksachenEntityResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'modifyVerschlusssache');
        throwIfNullOrUndefined(verschlusssacheRequestDTO, 'verschlusssacheRequestDTO', 'modifyVerschlusssache');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksachenEntityResponseDTO>({
            url: '/print/drucksachen/{id}/verschlusssache'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: verschlusssacheRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Versendet eine Mail mit dem PDF Tagesausdruck an die ausgewählten Empfänger
     * Versendet die PDF Tagesausdruck
     */
    sendTagesausdruck({ tagesausdruckMailRequestDTO }: SendTagesausdruckRequest): Observable<void>
    sendTagesausdruck({ tagesausdruckMailRequestDTO }: SendTagesausdruckRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    sendTagesausdruck({ tagesausdruckMailRequestDTO }: SendTagesausdruckRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(tagesausdruckMailRequestDTO, 'tagesausdruckMailRequestDTO', 'sendTagesausdruck');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/print/tagesausdruck/send',
            method: 'POST',
            headers,
            body: tagesausdruckMailRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Aktualisiert die Drucksachendaten der, mit der ID angegebene, Drucksache
     * Aktualisiert die Drucksachendaten einer Drucksache
     */
    setDrucksache({ id, drucksachendatenRequestDTO }: SetDrucksacheRequest): Observable<DrucksacheResponseDTO>
    setDrucksache({ id, drucksachendatenRequestDTO }: SetDrucksacheRequest, opts?: OperationOpts): Observable<AjaxResponse<DrucksacheResponseDTO>>
    setDrucksache({ id, drucksachendatenRequestDTO }: SetDrucksacheRequest, opts?: OperationOpts): Observable<DrucksacheResponseDTO | AjaxResponse<DrucksacheResponseDTO>> {
        throwIfNullOrUndefined(id, 'id', 'setDrucksache');
        throwIfNullOrUndefined(drucksachendatenRequestDTO, 'drucksachendatenRequestDTO', 'setDrucksache');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<DrucksacheResponseDTO>({
            url: '/print/drucksachen/{id}/drucksachendaten'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: drucksachendatenRequestDTO,
        }, opts?.responseOpts);
    };

    /**
     * Aktualisiert die mit der ID angegebene Bemerkung einer Drucksache
     * Aktualisiert eine vorhandene Bemerkung an einer Drucksache
     */
    updateBemerkung({ id, drucksachenBemerkungenEntityDTO }: UpdateBemerkungRequest): Observable<void>
    updateBemerkung({ id, drucksachenBemerkungenEntityDTO }: UpdateBemerkungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>>
    updateBemerkung({ id, drucksachenBemerkungenEntityDTO }: UpdateBemerkungRequest, opts?: OperationOpts): Observable<void | AjaxResponse<void>> {
        throwIfNullOrUndefined(id, 'id', 'updateBemerkung');
        throwIfNullOrUndefined(drucksachenBemerkungenEntityDTO, 'drucksachenBemerkungenEntityDTO', 'updateBemerkung');

        const headers: HttpHeaders = {
            'Content-Type': 'application/json',
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
            ...(this.configuration.username != null && this.configuration.password != null ? { Authorization: `Basic ${btoa(this.configuration.username + ':' + this.configuration.password)}` } : undefined),
        };

        return this.request<void>({
            url: '/print/bemerkungen/{id}'.replace('{id}', encodeURI(id)),
            method: 'PUT',
            headers,
            body: drucksachenBemerkungenEntityDTO,
        }, opts?.responseOpts);
    };

}
